//+------------------------------------------------------------------+
//|                                  BBands_Stop Histo_v3.0 600+.mq4 |
//|                        Copyright  2006-14, TrendLaboratory Ltd. |
//|            http://finance.groups.yahoo.com/group/TrendLaboratory |
//|                                   E-mail: igorad2003@yahoo.co.uk |
//+------------------------------------------------------------------+
#property copyright "Copyright  2006-14, TrendLaboratory"
#property link      "http://finance.groups.yahoo.com/group/TrendLaboratory"

#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1 DodgerBlue
#property indicator_color2 Magenta
#property indicator_width1  2
#property indicator_width2  2

#property indicator_minimum 0 
  
//---- input parameters
extern int     TimeFrame            =     0;    // TimeFrame in min
extern int     UpBandPrice          =     0;    // Upper Band Price(ex.2 for High)     
extern int     LoBandPrice          =     0;    // Lower Band Price(ex.3 for Low) 
extern int     MA_Length            =    15;    // Bollinger Bands Period
extern int     MA_Mode              =     0;    // Mode of Moving Average  
extern double  Deviation            =     1;    // Deviation
extern int     DeviationLength      =    20;    // Period of Standard Deviation
extern double  IndicatorValue       =     1;   // Indicator Value (ex.1.0) 

extern string  alerts               = "--- Alerts & Emails ---";
extern int     AlertMode            =     0;
extern int     SoundsNumber         =     5;    //Number of sounds after Signal
extern int     SoundsPause          =     5;    //Pause in sec between sounds 
extern string  UpSound              = "alert.wav";
extern string  DnSound              = "alert2.wav";
extern int     EmailMode            =     0;    //0-on,1-off   
extern int     EmailsNumber         =     1;    //0-on,1-off


//---- indicator buffers
double UpTrend[];
double DnTrend[];
double trend[];


double   upband1[2], dnband1[2]; 
datetime prevtime, preTime, ptime;
string   short_name, TF, IndicatorName, prevmess, prevemail;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
{
   
   if(TimeFrame <= Period()) TimeFrame = Period();
   TF = tf(TimeFrame);
   
//---- 
   IndicatorBuffers(3);
   SetIndexBuffer(0,UpTrend); SetIndexStyle(0,DRAW_HISTOGRAM); 
   SetIndexBuffer(1,DnTrend); SetIndexStyle(1,DRAW_HISTOGRAM); 
   SetIndexBuffer(2,  trend);
   
   IndicatorDigits(MarketInfo(Symbol(),MODE_DIGITS));
//---- 
   IndicatorName = WindowExpertName(); 
   short_name    = IndicatorName+"["+TF+"]("+UpBandPrice+","+LoBandPrice+","+MA_Length+","+DeviationLength+","+DoubleToStr(Deviation,2)+")";
   IndicatorShortName(short_name);
   SetIndexLabel(0,"UpTrend");
   SetIndexLabel(1,"DnTrend");
   
//----
   SetIndexDrawBegin(0,MA_Length+DeviationLength);
   SetIndexDrawBegin(1,MA_Length+DeviationLength);
   
//----
   return(0);
}

//+------------------------------------------------------------------+
//| BBands_Stop Histo_v3.0 600+                                      |
//+------------------------------------------------------------------+
int start()
{
   int shift,limit, counted_bars=IndicatorCounted();
      
   if(counted_bars > 0) limit = Bars - counted_bars - 1;
   if(counted_bars < 0) return(0);
   if(counted_bars < 1)
   { 
   limit = Bars-1;   
      for(int i=0;i<limit;i++)
      { 
      UpTrend[i]  = EMPTY_VALUE;
      DnTrend[i]  = EMPTY_VALUE;
      }
   }   
   
   
   if(TimeFrame != Period())
	{
   limit = MathMax(limit,TimeFrame/Period());   
      
      for(shift = 0;shift < limit;shift++) 
      {	
      int y = iBarShift(NULL,TimeFrame,Time[shift]);
      
      
      UpTrend[shift]  = iCustom(NULL,TimeFrame,IndicatorName,0,UpBandPrice,LoBandPrice,MA_Length,MA_Mode,Deviation,DeviationLength,IndicatorValue,
                                "",AlertMode,SoundsNumber,SoundsPause,UpSound,DnSound,EmailMode,EmailsNumber,0,y);
                                      
      DnTrend[shift]  = iCustom(NULL,TimeFrame,IndicatorName,0,UpBandPrice, LoBandPrice,MA_Length,MA_Mode,Deviation,DeviationLength,IndicatorValue,
                                "",AlertMode,SoundsNumber,SoundsPause,UpSound,DnSound,EmailMode,EmailsNumber,1,y);      
      
      }  
	
	return(0);
	}
	else
	{
      for(shift=limit;shift>=0;shift--) 
      {	
         if(prevtime != Time[shift])
         {
         upband1[1] = upband1[0];
         dnband1[1] = dnband1[0];
         prevtime   = Time[shift];
         }
   
      
      double upMA = iMA(NULL,0,MA_Length,0,MA_Mode,UpBandPrice,shift);
      double dnMA = iMA(NULL,0,MA_Length,0,MA_Mode,LoBandPrice,shift);
	
      double upStdDev = iStdDev(NULL,0,DeviationLength,0,MA_Mode,UpBandPrice,shift);
      double dnStdDev = iStdDev(NULL,0,DeviationLength,0,MA_Mode,LoBandPrice,shift);
			  
      upband1[0] = upMA + Deviation*upStdDev;
      dnband1[0] = dnMA - Deviation*dnStdDev;
         
      trend[shift] = trend[shift+1];
	
      if(Close[shift] > upband1[1]) trend[shift] = 1; 
      if(Close[shift] < dnband1[1]) trend[shift] =-1;
		  
      UpTrend[shift]  = EMPTY_VALUE;  
      DnTrend[shift]  = EMPTY_VALUE;  
      
         if(trend[shift] > 0)
         {
         if(dnband1[0] < dnband1[1]) dnband1[0] = dnband1[1];
         UpTrend[shift] = IndicatorValue;
	      }      
	  
         if(trend[shift] < 0)
         {
         if(upband1[0] > upband1[1]) upband1[0] = upband1[1];
         DnTrend[shift] = IndicatorValue;
         }      
      }
//----
      if(AlertMode > 0)
      {
      bool uptrend = trend[1] > 0 && trend[2] <= 0;                  
      bool dntrend = trend[1] < 0 && trend[2] >= 0;
        
         if(uptrend || dntrend)
         {
            if(isNewBar(TimeFrame))
            {
            BoxAlert(uptrend," : BUY Signal at " +DoubleToStr(Close[1],Digits));   
            BoxAlert(dntrend," : SELL Signal at "+DoubleToStr(Close[1],Digits)); 
            }
      
         WarningSound(uptrend,SoundsNumber,SoundsPause,UpSound,Time[1]);
         WarningSound(dntrend,SoundsNumber,SoundsPause,DnSound,Time[1]);
         
            if(EmailMode > 0)
            {
            EmailAlert(uptrend,"BUY" ," : BUY Signal at " +DoubleToStr(Close[1],Digits),EmailsNumber); 
            EmailAlert(dntrend,"SELL"," : SELL Signal at "+DoubleToStr(Close[1],Digits),EmailsNumber); 
            }
         }
      }
   }   
   
	 	         
//----	
	return(0);	
}

bool isNewBar(int tf)
{
   static datetime pTime;
   bool res=false;
   
   if(tf >= 0)
   {
      if (iTime(NULL,tf,0)!= pTime)
      {
      res=true;
      pTime=iTime(NULL,tf,0);
      }   
   }
   else res = true;
   
   return(res);
}

bool BoxAlert(bool cond,string text)   
{      
   string mess = IndicatorName + "("+Symbol()+","+TF + ")" + text;
   
   if (cond && mess != prevmess)
	{
	Alert (mess);
	prevmess = mess; 
	return(true);
	} 
  
   return(false);  
}

bool Pause(int sec)
{
   if(TimeCurrent() >= preTime + sec) {preTime = TimeCurrent(); return(true);}
   
   return(false);
}

void WarningSound(bool cond,int num,int sec,string sound,datetime ctime)
{
   static int i;
   
   if(cond)
   {
   if(ctime != ptime) i = 0; 
   if(i < num && Pause(sec)) {PlaySound(sound); ptime = ctime; i++;}       	
   }
}

bool EmailAlert(bool cond,string text1,string text2,int num)   
{      
   string subj = "New " + text1 +" Signal from " + IndicatorName + "!!!";    
   string mess = IndicatorName + "("+Symbol()+","+TF + ")" + text2;
   
   if (cond && mess != prevemail)
	{
	if(subj != "" && mess != "") for(int i=0;i<num;i++) SendMail(subj, mess);  
	prevemail = mess; 
	return(true);
	} 
  
   return(false);  
}	         
 
string tf(int timeframe)
{
   switch(timeframe)
   {
   case PERIOD_M1:   return("M1");
   case PERIOD_M5:   return("M5");
   case PERIOD_M15:  return("M15");
   case PERIOD_M30:  return("M30");
   case PERIOD_H1:   return("H1");
   case PERIOD_H4:   return("H4");
   case PERIOD_D1:   return("D1");
   case PERIOD_W1:   return("W1");
   case PERIOD_MN1:  return("MN1");
   default:          return("Unknown timeframe");
   }
}                  